// Fragment Shader

#version 330 core

out vec4 final_color;

uniform sampler2D texSampler1;//color
uniform sampler2D texSampler2;//info1. lindepth + normals(+fail)

uniform float darken;

in vec2 tex;


void main(void)
{

	//vec3 center = texture(texSampler2, tex).rgb;
	//vec3 right = textureOffset(texSampler2, tex, ivec2(1,0)).rgb;
	//vec3 left = textureOffset(texSampler2, tex, ivec2(-1,0)).rgb;
	//vec3 bottom = textureOffset(texSampler2, tex, ivec2(0,-1)).rgb;
	//vec3 top = textureOffset(texSampler2, tex, ivec2(0,1)).rgb;
	//
	//float dx_r = abs(dot(center, right));
	//float dx_l = abs(dot(center, left));
	//float dy_b = abs(dot(center, bottom));
	//float dy_t = abs(dot(center, top));

	//vec3 center = texture(texSampler1, tex).rgb;
	//vec3 right = textureOffset(texSampler1, tex, ivec2(1,0)).rgb;
	//vec3 left = textureOffset(texSampler1, tex, ivec2(-1,0)).rgb;
	//vec3 bottom = textureOffset(texSampler1, tex, ivec2(0,-1)).rgb;
	//vec3 top = textureOffset(texSampler1, tex, ivec2(0,1)).rgb;
	//
	//float dx_r = abs(dot(center, right));
	//float dx_l = abs(dot(center, left));
	//float dy_b = abs(dot(center, bottom));
	//float dy_t = abs(dot(center, top));

	//float difference = min( min(dx_r,dx_l), min(dy_t, dy_b)  );


	//vec4 edge = vec4(0);

	//const float T=0.05;
	//const float T=0.05;
	//if( (dx > T) || (dy > T) )
	//if(difference > T)
	//if(difference < T)
		//final_color = vec4(vec3(0.2), 1.0);
	//	edge = vec4(vec3(1), 1.0);
	//else
		//final_color = vec4(vec3(0.8), 1.0);
	//	edge = vec4(vec3(0), 1.0);
		//final_color = vec4(abs(center), 1.0);
	//if(center == vec3(0)) edge = vec4(1,1,1,1);

	//vec4 color =  texture(texSampler1, tex);
	
	//if(color.a < 1) final_color = color;
	//else final_color = vec4(color.r * edge.r, color.g * edge.g, color.b * edge.b, 1);
	
	//final_color = color*0.5 + 0.5*edge;
	
	//final_color = vec4(texture(texSampler2, tex).rgb, 1.0);

	//final_color = vec4(vec3(texture(texSampler2, tex).a),1.0);
	//final_color = texture(texSampler1, tex);
	
	//final_color = vec4(vec3(-left + right - top + bottom+3*center),1); //edge a
	//final_color = vec4((-left + right - top + bottom + center),1);//sharpen rgb
	//final_color = vec4((0*center + 4*left + 4*right + 4*top + 4*bottom)/16,1);//blur rgb


	//DOF -----------, tex2.a = depth, 0 is close 1 is far
	/*
	float z = -50 + 300 * texture(texSampler2, tex).a;
	if(z > 1) z = 1; if (z < 0 ) z = 0;
	vec3 sharp = texture(texSampler1, tex).rgb;
	
	vec3 right = textureOffset(texSampler1, tex, ivec2(1,0)).rgb;
	vec3 left = textureOffset(texSampler1, tex, ivec2(-1,0)).rgb;
	vec3 bottom = textureOffset(texSampler1, tex, ivec2(0,-1)).rgb;
	vec3 top = textureOffset(texSampler1, tex, ivec2(0,1)).rgb;
	vec3 ru = textureOffset(texSampler1, tex, ivec2(1,1)).rgb;
	vec3 rd = textureOffset(texSampler1, tex, ivec2(1,-1)).rgb;
	vec3 ld = textureOffset(texSampler1, tex, ivec2(-1,-1)).rgb;
	vec3 lu = textureOffset(texSampler1, tex, ivec2(-1,1)).rgb;

	vec3 blur = (0*sharp + left + right + top + bottom + ru + rd + ld + lu)/8;

	final_color =vec4( ( (1-z) * sharp + z * blur ) , 1.0);
	if (final_color.r <=  0 &&final_color.g <=  0 && final_color.b <=  0) final_color.a = 0;
	*/

	//EDGES
	
	float center = texture(texSampler2, tex).r;
	float r = textureOffset(texSampler2, tex, ivec2(1,0)).r;
	float l = textureOffset(texSampler2, tex, ivec2(-1,0)).r;
	float b = textureOffset(texSampler2, tex, ivec2(0,-1)).r;
	float t = textureOffset(texSampler2, tex, ivec2(0,1)).r;
	
	float rt = textureOffset(texSampler2, tex, ivec2(1,1)).r;
	float lt = textureOffset(texSampler2, tex, ivec2(-1,1)).r;
	float rb = textureOffset(texSampler2, tex, ivec2(1,-1)).r;
	float lb = textureOffset(texSampler2, tex, ivec2(-1,-1)).r;
	
	float dx_r = abs(center - r);
	float dx_l = abs(center - l);
	float dy_b = abs(center - b);
	float dy_t = abs(center - t);
	float dx_rt = abs(center - rt);
	float dx_lt = abs(center - lt);
	float dy_rb = abs(center - rb);
	float dy_lb = abs(center - lb);
	/*
	float maxdif = max(max(max(dx_r,dx_l),max(dy_b,dy_t)),max(max(dx_rt,dx_lt),max(dy_rb,dy_lb)));

	float eps = 0.01;
	if (maxdif > eps) {
		final_color = vec4(vec3(0),1);
	} else {
		final_color = vec4(vec3(0,.5,.5),1);
		//final_color = texture(texSampler1, tex);
	}
	*/
	float sobel = abs(-rt - 2*r - rb + lt + 2*l +lb) + abs(-rt - 2*t - lt + rb + 2*b + lb);
	if (sobel  < 0.05) {
		sobel = 0;
	} else {
		sobel = 1;
	}
	final_color = texture(texSampler1, tex) - vec4(vec3(sobel),0);
	
	//final_color = texture(texSampler2, tex);
	//if (maxdif<eps) maxdif = 0; else maxdif = 1;
	//final_color = vec4(vec3(maxdif),1);

	//final_color = texture(texSampler1, tex);

	final_color.xyz = final_color.xyz*darken;
}

