// Vertex Shader

#version 330 core

layout(location = 0) in vec3 in_position;

uniform mat4 viewMatrix;
out vec3 out_position;

void main(void)
{
	out_position = in_position;
	gl_Position =viewMatrix * vec4(in_position, 1.0);
	gl_PointSize = 5.0;
	
}
