#version 330 core

layout(location = 0) in vec2 in_pos_screen;
layout(location = 1) in vec2 in_tex;

out vec2 UV;

void main(){

	//1024,768 ->  -1,1
	vec2 pos_homogenous = in_pos_screen / vec2(1024/2,768/2);
	pos_homogenous = pos_homogenous - 1;

	//pos_homogenous = in_pos_screen - vec2(400,300); // [0..800][0..600] -> [-400..400][-300..300]
	//pos_homogenous /= vec2(400,300);

	gl_Position =  vec4(pos_homogenous,0,1);
	
	UV = in_tex;
}

